"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwcJsMinimizerPlugin = void 0;
const base_1 = require("./base");
function getMinifyCondition(condition) {
    if (typeof condition === "string") {
        return {
            type: "string",
            stringMatcher: condition
        };
    }
    if (condition instanceof RegExp) {
        return {
            type: "regexp",
            regexpMatcher: condition.source
        };
    }
    throw new Error("unreachable: condition should be one of string, RegExp");
}
function getMinifyConditions(condition) {
    if (!condition)
        return undefined;
    if (Array.isArray(condition)) {
        return {
            type: "array",
            arrayMatcher: condition.map(i => getMinifyCondition(i))
        };
    }
    return getMinifyCondition(condition);
}
exports.SwcJsMinimizerPlugin = (0, base_1.create)(base_1.BuiltinPluginKind.SwcJsMinimizer, (options) => {
    var _a, _b, _c, _d;
    return {
        passes: (_a = options === null || options === void 0 ? void 0 : options.passes) !== null && _a !== void 0 ? _a : 1,
        dropConsole: (_b = options === null || options === void 0 ? void 0 : options.dropConsole) !== null && _b !== void 0 ? _b : false,
        pureFuncs: (_c = options === null || options === void 0 ? void 0 : options.pureFuncs) !== null && _c !== void 0 ? _c : [],
        comments: (options === null || options === void 0 ? void 0 : options.comments) ? options.comments : "false",
        asciiOnly: (_d = options === null || options === void 0 ? void 0 : options.asciiOnly) !== null && _d !== void 0 ? _d : false,
        extractComments: (options === null || options === void 0 ? void 0 : options.extractComments)
            ? String(options.extractComments)
            : undefined,
        test: getMinifyConditions(options === null || options === void 0 ? void 0 : options.test),
        include: getMinifyConditions(options === null || options === void 0 ? void 0 : options.include),
        exclude: getMinifyConditions(options === null || options === void 0 ? void 0 : options.exclude)
    };
});
