import * as binding from "@rspack/binding";
import { Compiler, RspackPluginInstance } from "..";
export declare enum BuiltinPluginKind {
    Define = "Define",
    Provide = "Provide",
    Banner = "Banner",
    Progress = "Progress",
    Copy = "Copy",
    Html = "Html",
    SwcJsMinimizer = "SwcJsMinimizer",
    SwcCssMinimizer = "SwcCssMinimizer",
    Entry = "Entry",
    Externals = "Externals",
    NodeTarget = "NodeTarget",
    ElectronTarget = "ElectronTarget",
    HttpExternals = "HttpExternals"
}
export declare abstract class RspackBuiltinPlugin implements RspackPluginInstance {
    abstract raw(): binding.BuiltinPlugin;
    apply(compiler: Compiler): void;
}
export declare function create<T extends any[], R>(kind: BuiltinPluginKind, resolve: (...args: T) => R): {
    new (...args: T): {
        _options: R;
        raw(): binding.BuiltinPlugin;
        apply(compiler: Compiler): void;
    };
};
