"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.RspackBuiltinPlugin = exports.BuiltinPluginKind = void 0;
// TODO: workaround for https://github.com/napi-rs/napi-rs/pull/1690
var BuiltinPluginKind;
(function (BuiltinPluginKind) {
    BuiltinPluginKind["Define"] = "Define";
    BuiltinPluginKind["Provide"] = "Provide";
    BuiltinPluginKind["Banner"] = "Banner";
    BuiltinPluginKind["Progress"] = "Progress";
    BuiltinPluginKind["Copy"] = "Copy";
    BuiltinPluginKind["Html"] = "Html";
    BuiltinPluginKind["SwcJsMinimizer"] = "SwcJsMinimizer";
    BuiltinPluginKind["SwcCssMinimizer"] = "SwcCssMinimizer";
    BuiltinPluginKind["Entry"] = "Entry";
    BuiltinPluginKind["Externals"] = "Externals";
    BuiltinPluginKind["NodeTarget"] = "NodeTarget";
    BuiltinPluginKind["ElectronTarget"] = "ElectronTarget";
    BuiltinPluginKind["HttpExternals"] = "HttpExternals";
})(BuiltinPluginKind = exports.BuiltinPluginKind || (exports.BuiltinPluginKind = {}));
class RspackBuiltinPlugin {
    apply(compiler) {
        compiler.__internal__registerBuiltinPlugin(this);
    }
}
exports.RspackBuiltinPlugin = RspackBuiltinPlugin;
function create(kind, resolve) {
    return class Plugin extends RspackBuiltinPlugin {
        constructor(...args) {
            var _a;
            super();
            this._options =
                (_a = resolve(...args)) !== null && _a !== void 0 ? _a : false /* undefined or null will cause napi error, so false for fallback */;
        }
        raw() {
            return {
                kind: kind,
                options: this._options
            };
        }
    };
}
exports.create = create;
