import type Watching from "./Watching";
export * from "./Compiler";
export * from "./MultiCompiler";
export * from "./Compilation";
export * from "./config";
export * from "./rspack";
export { RuntimeGlobals } from "./RuntimeGlobals";
export * from "./Stats";
export * from "./MultiStats";
export * from "./ChunkGroup";
export * from "./NormalModuleFactory";
export { cachedCleverMerge as cleverMerge } from "./util/cleverMerge";
export { BannerPlugin } from "./lib/BannerPlugin";
export { EnvironmentPlugin } from "./lib/EnvironmentPlugin";
export { LoaderOptionsPlugin } from "./lib/LoaderOptionsPlugin";
export { registerGlobalTrace as experimental_registerGlobalTrace, cleanupGlobalTrace as experimental_cleanupGlobalTrace } from "@rspack/binding";
import { Configuration } from "./config";
export type OptimizationSplitChunksOptions = NonNullable<Configuration["optimization"]>["splitChunks"];
export { DefinePlugin, ProvidePlugin, ProgressPlugin, HtmlPlugin, SwcJsMinimizerPlugin, SwcCssMinimizerPlugin, CopyPlugin, EntryPlugin, ExternalsPlugin } from "./builtin-plugin";
export type { DefinePluginOptions, ProvidePluginOptions, ProgressPluginOptions, BannerPluginOptions, HtmlPluginOptions, SwcJsMinimizerPluginOptions, CopyPluginOptions, EntryOptions } from "./builtin-plugin";
export declare const node: {
    NodeTargetPlugin: {
        new (): {
            _options: undefined;
            raw(): import("@rspack/binding").BuiltinPlugin;
            apply(compiler: import("./Compiler").Compiler): void;
        };
    };
};
export declare const electron: {
    ElectronTargetPlugin: {
        new (context?: string | undefined): {
            _options: string;
            raw(): import("@rspack/binding").BuiltinPlugin;
            apply(compiler: import("./Compiler").Compiler): void;
        };
    };
};
export { Watching };
